<?php
// +-----------------------------------------------------------------------+
// |                                                                       |
// | THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS   |
// | "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT     |
// | LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR |
// | A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT  |
// | OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, |
// | SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT      |
// | LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, |
// | DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY |
// | THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT   |
// | (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE |
// | OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.  |
// |                                                                       |
// +-----------------------------------------------------------------------+


if (!function_exists('LoadPrefs')){
    function LoadPrefs() {
        global $datadir;
        if (file_exists($datadir.'/sitemgr.txt'))
        {
            unset($GLOBALS["access"]);
            $GLOBALS["access"]=array();
            $handle = fopen($datadir.'/sitemgr.txt', 'r');
            while (($data = fgetcsv($handle, 1000, "|")) !== FALSE) {
                $host=preg_replace("/^(http)\:\/\//","",$data[0]);
                $host=explode("/",$host);
                $theArray = array($data[1], trim($data[2]));
                //$GLOBALS["access"] = array();
                $GLOBALS["access"] = array_push_assoc($GLOBALS["access"], $host[0], $theArray);
                //array_push($access[$host[0]][], $theArray);
            }
            fclose($handle);
        }
    }
}

if (!function_exists('File_Size')){
    function File_Size($file) {
        if (is_readable($file)) {
            $size = exec ('stat -c %s '. escapeshellarg ($file));
            return $size;
        }
    }
}

if (!function_exists('GetDeviceInfo')){
    function GetDeviceInfo($device) {
        global $datadir;
        $device_values=explode(" ",trim($device));

        $device_data[1] = $device_values[2]."/";
        $is_hidden=GetDriveParams($device_data[1], 3);
        if ($is_hidden != 1) {
            if (GetDriveParams($device_values[2]."/",2) == '')
                $device_data[0]=$device_values[0]." ".$device_values[1]." ".$device_values[2];
            else
                $device_data[0]=GetDriveParams($device_values[2]."/",2);

            if (GetDriveParams($device_values[2]."/",1) == '')
                $device_data[6]=0;
            else
                $device_data[6]=1;

            if(is_writable($device_values[2]))
                $device_data[4]=1;
            else
                $device_data[4]=0;

            if(is_readable($device_values[2]))
                $device_data[5]=1;
            else
                $device_data[5]=0;

            if ($device_values[0] == "rootfs" || $device_values[0] == "proc" || $device_values[0] == "sysfs" ||
                $device_values[0] == "tmpfs" || $device_values[0] == "usbfs" || $device_values[0] == "/dev/sigmblocke" ||
                $device_values[0] == "/dev/sigmblockm" || $device_values[0] == "/dev/sigmblockn" ||
                $device_values[0] == "/dev/sigmblocko" || $device_values[0] == "/dev/sigmblockf" ||
                $device_values[0] == "/dev/nblock8" ){
                $device_data[2]='ramdrive.png';
                $device_data[3]='Ram Drive';
            } else if ($device_values[0] == "/dev/cdrom" || $device_values[0] == "/dev/sr0") {
                $device_data[2]='dvddrive.png';
                $device_data[3]='CD/DVD Drive';
            } else if (substr($device_values[0],0,8) == "/dev/hda"){
                $device_data[2]='harddrive.png';
                $device_data[3]='Local Disk';
                $device_data[6]=1;
            } else if (substr($device_values[0],0,8) == "/dev/sda"){
                if (strpos($device_values[2], "USB_DRIVE")) {
                    $device_data[2]='usbdrive.png';
                    $device_data[3]='Removable Disk';
                    $device_data[6]=0;
                }
                else {
                    $device_data[2]='harddrive.png';
                    $device_data[3]='Local Disk';
                    $device_data[6]=1;
                }
            }
            $device_data[7]=strtoupper($device_values[3]);
            $device_data[8]=$device_values[0];
            return $device_data;
        }
    }
}

if (!function_exists('GetDriveParams')){
    function GetDriveParams($drive, $params) {
        global $datadir;
        $drive_array = file($datadir."/drive_params");

        foreach($drive_array as $drive_params) {
            $drive_mount = explode("|",$drive_params);
            if ($drive == $drive_mount[1]."/")
                return $drive_mount[$params];
        }
    }
}

if (!function_exists('SetDriveParams')){
    function SetDriveParams($drive, $params, $value) {
        global $datadir;
        $drive_array = file($datadir."/drive_params");

        $cnt=0;
        foreach($drive_array as $drive_params) {
            $drive_mount = explode("|",$drive_params);
            if ($drive == $drive_mount[1]."/") {
                if ($params == 3)
                    $drive_mount[$params] = $value."\n";
                else
                    $drive_mount[$params] = $value;
                $drive_array[$cnt] = implode("|",$drive_mount);
                break;
            }
            $cnt++;
        }
        $fp = fopen($datadir."/drive_params","w+");
        if ($fp)
            foreach($drive_array as $line) { fwrite($fp,$line); }
        fclose($fp);
    }
}

if (!function_exists('LoadMimes')){
    function LoadMimes() {
        global $datadir;
        if (file_exists($datadir.'/mimes.txt'))
        {
            unset($GLOBALS["access"]);
            $GLOBALS["mimes"]=array();
            $handle = fopen($datadir.'/mimes.txt', 'r');
            while (($data = fgetcsv($handle, 1000, "|")) !== FALSE) {
                $mime_type=$data[0];
                $description=$data[1];
                //$theArray = array($data[2]);
                $GLOBALS["mimes"] = array_push_assoc($GLOBALS["mimes"], $mime_type, $description);
                $theArray = array($GLOBALS["mimes"][$mime_type],$data[2]);
                $GLOBALS["super_mimes"] = array_push_assoc($GLOBALS["super_mimes"], $mime_type, $theArray);
                $extension = str_replace(".","\\.",$data[3]);
                $extension1 = str_replace(',','$|',$extension);
                if (strlen($extension1) > 0)
                    $extension1=$extension1.'$';
                $theArray1 = array($GLOBALS["mimes"][$mime_type],$data[2], $extension1);
                $GLOBALS["used_mime_types"] = array_push_assoc($GLOBALS["used_mime_types"], $mime_type, $theArray1);
            }
            fclose($handle);
        }
    }
}


if (!function_exists('get_mime_type')){
    function get_mime_type($item, $query) {
        if (count($GLOBALS["used_mime_types"]) == 0)
            LoadMimes();
        if (is_dir($item))
        {
            $mime_type = $GLOBALS["super_mimes"]["dir"][0];
            $image = $GLOBALS["super_mimes"]["dir"][1];

            if ($query == "img") return $image;
            else return $mime_type;
        }
        foreach($GLOBALS["used_mime_types"] as $mime) {
                list($desc,$img,$ext)   = $mime;
                if(@eregi($ext,$item)) {
                        $mime_type      = $desc;
                        $image          = $img;
                        if($query=="img") return $image;
                        else return $mime_type;
                }
        }
    }
}

if (!function_exists('array_push_assoc')){
    function array_push_assoc($array, $key, $value){
        $array[$key] = $value;
        return $array;
    }
}

if (!function_exists('killPid')){
    function killPid($pid)
    {
        shell_exec('kill -9 '.$pid);
    }
}

if (!function_exists('isPIDRunning')){
    function isPIDRunning($pid)
    {
        if ($pid)
        {
            $proc_dir="/proc/".$pid;
            if(file_exists($proc_dir))
            {
                //Pid is running
                return true;
            }else{
                //Pid is not running
                return false;
            }
        }
        else
            return false;
    }
}

if (!function_exists('file_put_contents')) {
    function file_put_contents($filename, $data) {
        $f = @fopen($filename, 'w');
        if (!$f) {
            return false;
        } else {
            $bytes = fwrite($f, $data);
            fclose($f);
            return $bytes;
        }
    }
}

if (!function_exists('parse_fsize')) {
    function parse_fsize($size) {               // parsed file size
        if($size >= 1073741824) {
                $size = round($size / 1073741824 * 100) / 100  . " GB";
        } elseif($size >= 1048576) {
                $size = round($size / 1048576 * 100 )/ 100  . " MB";
        } elseif($size >= 1024) {
                $size = round($size / 1024 * 100 )/ 100 . " KB";
        } else $size = $size . " Bytes";
        if($size==0) $size="-";

        return $size;
    }
}

if (!function_exists('parse_fsize_fm')) {
    function parse_fsize_fm($size) {               // parsed file size
        if($size >=1024)
            $size=round($size / 1024);
        elseif($size <1024 && $size > 0)
            $size=1;
        elseif($size==0) $size=0;

        return $size;
    }
}

if (!function_exists('pretty_number')) {
    function pretty_number($size) { 
        $len=strlen($size);
        $place=0;
        $outval="";
        while ($len > 0) {
            $digit=substr($size,$len-1, 1);
            if ($place >= 3){
                $place = 0;
                $outval=$digit.",".$outval;
            }
            else
                $outval=$digit.$outval;
            $len--;
            $place++;
        }
        return($outval);
    }
}

if (!function_exists('get_file_perms')) {
    function get_file_perms($dir,$item) {           // file permissions
        return @decoct(@fileperms(get_abs_item($dir,$item)) & 0777);
    }
}

if (!function_exists('get_abs_item')) {
    function get_abs_item($dir, $item) {            // get absolute file+path
        return get_abs_dir($dir)."/".$item;
    }
}

if (!function_exists('get_abs_dir')) {
    function get_abs_dir($dir) {                    // get absolute path
        $abs_dir=$GLOBALS["rootdir"];
        if($dir!="") $abs_dir.="/".$dir;
        return $abs_dir;
    }
}

if (!function_exists('parse_file_perms')) {
    function parse_file_perms($mode) {              // parsed file permisions
        if(strlen($mode)<3) return "---------";
        $parsed_mode="";
        for($i=0;$i<3;$i++) {
                // read
                if(($mode{$i} & 04)) $parsed_mode .= "r";
                else $parsed_mode .= "-";
                // write
                if(($mode{$i} & 02)) $parsed_mode .= "w";
                else $parsed_mode .= "-";
                // execute
                if(($mode{$i} & 01)) $parsed_mode .= "x";
                else $parsed_mode .= "-";
        }
        return $parsed_mode;
    }
}

if (!function_exists('RecursiveDelete')) {
    function RecursiveDelete($dir, $DeleteMe) {
        if(!$dh = @opendir($dir)) return;
        while (false !== ($obj = readdir($dh))) {
            if($obj=='.' || $obj=='..') continue;
            if (!@unlink($dir.'/'.$obj)) RecursiveDelete($dir.'/'.$obj, true);
        }
    
        closedir($dh);
        if ($DeleteMe){
            @rmdir($dir);
        }
    }
}
if (!function_exists('dirSize')) {
    function dirSize($path) {
        // Init
        $size = 0;
        $file_count = 0;
        $dir_count = 0;
 
        // Trailing slash
        if (substr($path, -1, 1) !== DIRECTORY_SEPARATOR) {
            $path .= DIRECTORY_SEPARATOR;
        }
 
        // Sanity check
        if (is_file($path)) {
            return File_Size($path);
        } elseif (!is_dir($path)) {
            return false;
        }
 
        // Iterate queue
        $queue = array($path);
        for ($i = 0, $j = count($queue); $i < $j; ++$i) {
            // Open directory
            $parent = $i;
            if (is_dir($queue[$i]) && $dir = @dir($queue[$i])) {
                $subdirs = array();
                while (false !== ($entry = $dir->read())) {
                    // Skip pointers
                    if ($entry == '.' || $entry == '..') {
                        continue;
                    }
 
                    // Get list of directories or filesizes
                    $path = $queue[$i] . $entry;
                    if (is_dir($path)) {
                        $path .= DIRECTORY_SEPARATOR;
                        $subdirs[] = $path;
                        $dir_count++;
                    } elseif (is_file($path)) {
                        $file_count++;
                        $size += File_Size($path);
                    }
                }
     
                // Add subdirectories to start of queue
                unset($queue[0]);
                $queue = array_merge($subdirs, $queue);
     
                // Recalculate stack size
                $i = -1;
                $j = count($queue);
     
                // Clean up
                $dir->close();
                unset($dir);
            }
        }

        $file_info=array($size,$file_count, $dir_count);
 
        return $file_info;
    }
}

if (!function_exists('print_version')) {
    function print_version() {
        global $homedir;
        $appinfo=dirname($homedir)."/appinfo.json";
        if (file_exists($appinfo)){
        $data = file_get_contents($appinfo);
            if(preg_match("/version=\"(.*)\"/", $data, $version))
                return $version[1];
        }
        else
            return "unknown";
    }
}
?>
