<?php
// +-----------------------------------------------------------------------+
// |                                                                       |
// | THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS   |
// | "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT     |
// | LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR |
// | A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT  |
// | OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, |
// | SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT      |
// | LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, |
// | DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY |
// | THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT   |
// | (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE |
// | OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.  |
// |                                                                       |
// +-----------------------------------------------------------------------+

//include db connection settings
if(is_readable("_include/config.php"))
    include "_include/config.php";
else
    include "config.php";

if(is_readable("_include/functions.php"))
    include "_include/functions.php";
else
    include "functions.php";


global $tmpdir;
ini_set("session.save_path", $tmpdir);
ini_set("error_reporting", "E_ERROR");
session_start();

if ( stristr($_SERVER["HTTP_ACCEPT"],"application/xhtml+xml") ) {
    header("Content-type: application/xhtml+xml"); } else {
    header("Content-type: text/xml");
}
print("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
?>

<!-- start grid xml -->
<?php
require_once('_lib/getid3/getid3.php');
$getID3 = new getID3;
$getID3->setOption(array('encoding' => 'UTF-8'));

if (isset($_GET["type"]))
    $type=$_GET["type"];
else 
    $type="details";

if ($type == "details")
    print("<rows id='0'>\n");
else
    print("<data>");

global $rootdir, $date_format;

if (! isset($_GET["dir"]))
    $dirToScan = $rootdir;
else
    $dirToScan = $_GET["dir"];

if($dirToScan != "popcornhour") {
    $files = scandir($dirToScan);
    if($files!=false && count($files)>0 ){
        foreach($files as $file) {
            $style='';
            if ($file == ".music")
                continue;
            if ($file == ".photo")
                continue;
            if ($file == ".video")
                continue;

            $fileFullPath = $dirToScan.$file;
            //$mtimeArray = getdate(filemtime($fileFullPath));
                           
            //file size in bytes
            $actual_size = (float)File_Size($fileFullPath);
            $fsize = parse_fsize_fm($actual_size);
            $oct_perms=get_file_perms($dirToScan, $file);
            if ($oct_perms == 0)
                $perms = parse_file_perms(trim(exec('stat -c %a '.escapeshellarg($fileFullPath))));
            else
                $perms = parse_file_perms(get_file_perms($dirToScan, $file)).' ('.$oct_perms.')';
            $owner = posix_getpwuid(fileowner($fileFullPath));

            //format date as yyyy-m-d hh:mm:ss
            if (is_readable($fileFullPath))
                $fdate = date ($date_format, filemtime($fileFullPath));
            else
                $fdate = date ($date_format, trim(exec('stat -c %Z '.escapeshellarg($fileFullPath))));
    
            $image=get_mime_type($fileFullPath, "img");

            if ($image=="") $image="unknown.png";

            $ftype=get_mime_type($fileFullPath, "type");

            $extn="";
            $pos=strrpos(basename($fileFullPath), ".");
            if ($pos) {
                $len=strlen(basename($fileFullPath));
                $extn=strtoupper(substr(basename($fileFullPath),$pos+1,$len-$pos));
            }
            if ($ftype=="")
                $ftype=$extn." File";

            if (is_dir($fileFullPath)) {
                $fileFullPath=$fileFullPath.'/';
                $fsize="";
            }

            if (is_link($fileFullPath)) {
                if (file_exists($fileFullPath))
                    //$ftype="Symbolic Link to ".readlink($fileFullPath);
                    $ftype="Symbolic Link";
                else {
                    $ftype="Broken Link";
                    $style='color:red';
                }
            }

            if(is_writable($fileFullPath))
                $is_writable=1;
            else
                $is_writable=0;

            //output item 
            if ($type == "details") {
                $xmlID=str_replace("&","&amp;",$fileFullPath);
                $xmlID=str_replace('"',"&quot;",$xmlID);
                $xmlID=str_replace("'","&apos;",$xmlID);
                print("<row id='".$xmlID."' style='".$style."'>\n");
                print("<userdata name='is_writable'>".$is_writable."</userdata>\n");
                print("<userdata name='actual_size'>".$actual_size."</userdata>\n");
                print("<cell><![CDATA[_img/".$image."]]></cell>\n");
                print("<cell><![CDATA[".$file."]]></cell>\n");
                print("<cell><![CDATA[".$fsize."]]></cell>\n");
                print("<cell><![CDATA[".$ftype."]]></cell>\n");
                print("<cell><![CDATA[".$fdate."]]></cell>\n");
                print("<cell><![CDATA[".$perms."]]></cell>\n");
                print("<cell><![CDATA[".$owner['name']."]]></cell>\n");
                print("<cell><![CDATA[]]></cell>\n");
                print("<cell><![CDATA[]]></cell>\n");
                print("<cell><![CDATA[]]></cell>\n");
                print("<cell><![CDATA[]]></cell>\n");
                if (file_exists($dirToScan.'.music')) {
                    if ($extn == "MP3") {
                        $ThisFileInfo = $getID3->analyze($fileFullPath);
                        $id3_type=$ThisFileInfo['tags'];
                        if (count($id3_type) > 1)
                            $id3="id3v2";
                        else $id3=$id3_type[0];
                        print("<cell><![CDATA[".$ThisFileInfo['tags'][$id3]['artist'][0]."]]></cell>\n");
                        print("<cell><![CDATA[".$ThisFileInfo['tags'][$id3]['album'][0]."]]></cell>\n");
                        print("<cell><![CDATA[".$ThisFileInfo['tags'][$id3]['year'][0]."]]></cell>\n");
                        print("<cell><![CDATA[".$ThisFileInfo['tags'][$id3]['track_number'][0]."]]></cell>\n");
                        print("<cell><![CDATA[".$ThisFileInfo['playtime_string']."]]></cell>\n");
                        print("<cell><![CDATA[ ]]></cell>\n");
                        print("<cell><![CDATA[ ]]></cell>\n");
                    }
                }
                else if (file_exists($dirToScan.'.photo')) {
                    if ($extn == "JPG" || $extn == "GIF" || $extn == "PNG" || 
				$extn == "BMP" || $extn == "TIF") {
                        $ThisFileInfo = $getID3->analyze($fileFullPath);
                        print("<cell><![CDATA[ ]]></cell>\n");
                        print("<cell><![CDATA[ ]]></cell>\n");
                        print("<cell><![CDATA[ ]]></cell>\n");
                        print("<cell><![CDATA[ ]]></cell>\n");
                        print("<cell><![CDATA[ ]]></cell>\n");
                        print("<cell><![CDATA[".$ThisFileInfo['video']['resolution_x']." x ".$ThisFileInfo['video']['resolution_y']."]]></cell>");
                        $fdate="";
                        if (isset($ThisFileInfo['jpg']['exif']['IFD0']['DateTime'])) {
                            $tme=explode(":",str_replace(" ",":",$ThisFileInfo['jpg']['exif']['IFD0']['DateTime']));
                            $fdate = date($date_format,mktime($tme[3],$tme[4],$tme[5],$tme[1],$tme[2],$tme[0]));
                        }
                        else if (isset($ThisFileInfo['tiff']['comments']['datetime'][0])) {
                            $tme=explode(":",str_replace(" ",":",$ThisFileInfo['tiff']['comments']['datetime'][0]));
                            $fdate = date($date_format,mktime($tme[3],$tme[4],$tme[5],$tme[1],$tme[2],$tme[0]));
                        }
                        print("<cell><![CDATA[".$fdate."]]></cell>\n");
                    }
                }
                else if (file_exists($dirToScan.'.video')) {
                    if ($extn == "MPG" || $extn == "MOV" || $extn == "AVI" || 
				$extn == "MKV" || $extn == "WMV" || $extn == "MPEG" || 
				$extn == "RM" || $extn == "RA" || $extn == "RAM") {
                        $ThisFileInfo = $getID3->analyze($fileFullPath);
                        print("<cell><![CDATA[ ]]></cell>\n");
                        print("<cell><![CDATA[ ]]></cell>\n");
                        print("<cell><![CDATA[ ]]></cell>\n");
                        print("<cell><![CDATA[ ]]></cell>\n");
                        if (isset($ThisFileInfo['playtime_string']))
                            print("<cell><![CDATA[".$ThisFileInfo['playtime_string']."]]></cell>\n");
                        else
                            print("<cell><![CDATA[ ]]></cell>\n");
                        if (isset($ThisFileInfo['video']['resolution_x']))
                            print("<cell><![CDATA[".$ThisFileInfo['video']['resolution_x']." x ".$ThisFileInfo['video']['resolution_y']."]]></cell>\n");
                        else
                            print("<cell><![CDATA[ ]]></cell>\n");
                        print("<cell><![CDATA[ ]]></cell>\n");
                    }
                }
                else {
                    print("<cell><![CDATA[ ]]></cell>\n");
                    print("<cell><![CDATA[ ]]></cell>\n");
                    print("<cell><![CDATA[ ]]></cell>\n");
                    print("<cell><![CDATA[ ]]></cell>\n");
                    print("<cell><![CDATA[ ]]></cell>\n");
                    print("<cell><![CDATA[ ]]></cell>\n");
                    print("<cell><![CDATA[ ]]></cell>\n");
                }
                print("</row>\n");
            }
            else
            {
                if ($file != "." && $file != "..") {
                $xmlID=str_replace("&","&amp;",$fileFullPath);
                $xmlID=str_replace('"',"&quot;",$xmlID);
                $xmlID=str_replace("'","&apos;",$xmlID);

                print("<item id='".$xmlID."' name='".$file."' filetype='".$ftype."'>\n");
                print("<image>".$image."</image>\n");
                if ($fsize != "")
                    print("<filesize>".pretty_number($fsize)." KB</filesize>\n");
                else
                    print("<filesize></filesize>\n");
                print("<filetype>".$ftype."</filetype>\n");
                print("<modifdate>".$fdate."</modifdate>\n");
                print("</item>\n");
                }
            }
        //}
        }
    }
}
else {
    // get the list of devices
    $command = "mount|grep -v devpts|grep -v sysfs|grep -v usbfs|awk '{printf \"%s %s %s %s\\n\",$1,$2,$3,$5}' 1>_tmp/.devices";
    $status = shell_exec($command);
    $status=0;
    if ($status==0) {
        $device_array = file("_tmp/.devices");

        foreach($device_array as $device) {
            $device_data = GetDeviceInfo($device);

            if ($device_data) {
                $total_space = disk_total_space($device_data[1]); 
                $total_fsize = parse_fsize($total_space);
                $free_space = disk_free_space($device_data[1]); 
                $free_fsize = parse_fsize($free_space);
                if ($type == "details") {

                    // Row ID of grid
                    print("<row id='".$device_data[1]."'>\n");
                    print("<cell><![CDATA[_img/tree/".$device_data[2]."]]></cell>\n");
                    print("<cell><![CDATA[".$device_data[0]."]]></cell>\n");
                    print("<cell><![CDATA[]]></cell>\n");
                    print("<cell><![CDATA[".$device_data[3]."]]></cell>\n");
                    print("<cell><![CDATA[]]></cell>\n");
                    print("<cell><![CDATA[]]></cell>\n");
                    print("<cell><![CDATA[]]></cell>\n");
                    print("<cell><![CDATA[$total_fsize]]></cell>\n");
                    print("<cell><![CDATA[$free_fsize]]></cell>\n");
                    print("<cell><![CDATA[".$device_data[7]."]]></cell>\n");
                    print("<cell><![CDATA[]]></cell>\n");
                    print("</row>\n");
                }
                else {
                    print("<item id='".$device_data[1]."' name='".$device_data[0]."' filetype='".$device_data[3]."'>\n");
                    print("<image>".$device_data[2]."</image>\n");
                    print("<filetype>".$device_data[3]."</filetype>\n");
                    print("</item>\n");
                }
            }
        }
    }
}

print("<!-- close grid xml -->");
if ($type == "details")
    print("</rows>");
else
    print("</data>");
?>
