<?php
// +-----------------------------------------------------------------------+
// |                                                                       |
// | THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS   |
// | "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT     |
// | LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR |
// | A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT  |
// | OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, |
// | SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT      |
// | LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, |
// | DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY |
// | THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT   |
// | (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE |
// | OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.  |
// |                                                                       |
// +-----------------------------------------------------------------------+

//include db connection settings
if(is_readable("_include/config.php"))
    include "_include/config.php";
else
    include "config.php";

if(is_readable("_include/functions.php"))
    include "_include/functions.php";
else
    include "functions.php";

global $tmpdir;
ini_set("session.save_path", $tmpdir);
session_start();

if ( stristr($_SERVER["HTTP_ACCEPT"],"application/xhtml+xml") ) {
    header("Content-type: application/xhtml+xml"); } else {
    header("Content-type: text/xml");
}
echo("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n");
?>

<!-- start tree xml -->

<?php
$dirToScan = $GLOBALS["rootdir"];

if (isset($_GET["id"]) && $_GET["id"] != "popcornhour") {
    $fileFullPath = $_GET["id"];
    $len=0;
    echo '<tree id="'.htmlspecialchars($_GET["id"]).'">';

    $files = scandir($fileFullPath);
    if($files!=false && count($files)>0){
        foreach($files as $file) {
            $dirFullPath = $fileFullPath.$file;
            $pos=strrpos(basename($dirFullPath), ".");
            if ($pos)
                $len=strlen(basename($dirFullPath));

            if(is_dir($dirFullPath)) {
                if ($file == "." || $file == "..") {
                    //Do not print . and .. directories
                }
            else {
                    $no_dir=0;
                    $subfiles=scandir($dirFullPath);
                    if($subfiles != false && count($subfiles)>0){
                        foreach($subfiles as $subfile) {
                            $subdirFullPath = $dirFullPath.'/'.$subfile;
                            if (is_dir($subdirFullPath)){
                                    $no_dir++;
                            }
                        }
                    }

                    if(is_writable($dirFullPath))
                        $is_writable=1;
                    else
                        $is_writable=0;
                    if(is_readable($dirFullPath))
                        $is_readable=1;
                    else
                        $is_readable=0;
                    if ($no_dir >2)
                        $child=1;
                    else
                        $child=0;

                    if (file_exists($dirFullPath.'/.music'))
                        $content="Music";
                    else if (file_exists($dirFullPath.'/.photo'))
                        $content="Photo";
                    else if (file_exists($dirFullPath.'/.video'))
                        $content="Video";
                    else
                        $content="Documents";
            
                    print('<item text="'.htmlspecialchars($file).'" id="'.htmlspecialchars($dirFullPath).'/" child="'.$child.'" im0="folderClosed.png" im1="folderOpen.png" im2="folderFull.png">');
                    print('<userdata name="is_writable">'.$is_writable.'</userdata>');
                    print('<userdata name="is_readable">'.$is_readable.'</userdata>');
                    print('<userdata name="type">File Folder</userdata>');
                    print('<userdata name="content">'.$content.'</userdata>');
                    print('<userdata name="image">folderClosed.png</userdata></item>\n');
                }
            }
        }
    }
}
else if (isset($_GET["id"]) && $_GET["id"] == "popcornhour") {
    global $rootdir;

    $command = "mount|grep -v devpts|grep -v sysfs|grep -v usbfs|awk '{printf \"%s %s %s %s\\n\",$1,$2,$3,$5}' 1>_tmp/.devices";
    $status = shell_exec($command);
    $status=0;
    if ($status==0) {
        $device_array = file("_tmp/.devices");
        echo "<tree id=\"popcornhour\">\n";

        foreach($device_array as $device) {
            $device_data = GetDeviceInfo($device);

            if ($device_data) {
                echo "<item text='".$device_data[0]."' id='".$device_data[1]."' child='1' im0='".$device_data[2]."' im1='".$device_data[2]."' im2='".$device_data[2]."'>";
                print("<userdata name='is_writable'>".$device_data[4]."</userdata>");
                print("<userdata name='is_readable'>".$device_data[5]."</userdata>");
                print("<userdata name='type'>$device_data[3]</userdata>");
                print("<userdata name='is_internal'>$device_data[6]</userdata>");
                print("<userdata name='disk_id'>$device_data[8]</userdata>");
                print("<userdata name='filesystem'>$device_data[7]</userdata>");
                print("<userdata name='image'>$device_data[2]</userdata></item>\n");
            }
        }
    }
}
else {
    print("<tree id='0'>\n");
    print("<item text='My Popcorn Hour' id='popcornhour' child='1' im0='popcorn.png' im1='popcorn.png' im2='popcorn.png' select='1' open='1'>\n");
    print("<userdata name='is_writable'>0</userdata>\n");
    print("<userdata name='type'>Desktop</userdata>\n");
    print("<userdata name='image'>popcorn.png</userdata>\n");
    print("</item>\n");
}
?>
<!-- close tree xml -->
</tree>
