<?php
// +-----------------------------------------------------------------------+
// |                                                                       |
// | THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS   |
// | "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT     |
// | LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR |
// | A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT  |
// | OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, |
// | SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT      |
// | LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, |
// | DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY |
// | THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT   |
// | (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE |
// | OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.  |
// |                                                                       |
// +-----------------------------------------------------------------------+

if(is_readable("_include/config.php"))
    include "_include/config.php";
else
    include "config.php";

if(is_readable("_include/functions.php"))
    include "_include/functions.php";
else
    include "functions.php";

if (isset($_GET["item"]))
    $item=str_replace("\\","",$_GET["item"]);
    $baseitem=basename($item);
if (isset($_GET["type"]))
    $type=$_GET["type"];
else
    $type="Unknown File";

$location=dirname($_GET["item"]);

ini_set("error_reporting", "E_ERROR");

require_once('_lib/getid3/getid3.php');
$getID3 = new getID3;
$getID3->setOption(array('encoding' => 'UTF-8'));

$ThisFileInfo = $getID3->analyze($item);
getid3_lib::CopyTagsToComments($ThisFileInfo);
//print_r($ThisFileInfo);

$fileFullPath=$location.'/'.$baseitem;
echo "<body bgcolor=\"#f6f6ee\">\n";
echo "<table cellspacing=5 style=\"font-family:Tahoma;font-size:12px;\" width=\"100%\" style=\"margin:0px;\">\n";
// Audio Files
if (isset($ThisFileInfo['fileformat']) && $ThisFileInfo['fileformat'] == "mp3"){
    $id3_type = $ThisFileInfo['tags'];
    if (count($id3_type) > 1)
        $id3="id3v2";
    else $id3=$id3_type[0];
    echo "<tr><td align=\"left\"><b>Music</b></td></tr>\n";
    echo "<tr><td align=\"left\" >Artist:</td>\n";
    echo "<td align=\"left\">".$ThisFileInfo['tags'][$id3]['artist'][0]."</td></tr>\n";
    echo "<tr><td align=\"left\" >Album Title:</td>\n";
    echo "<td align=\"left\">".$ThisFileInfo['tags'][$id3]['album'][0]."</td></tr>\n";
    echo "<tr><td align=\"left\" >Year:</td>\n";
    echo "<td align=\"left\">".$ThisFileInfo['tags'][$id3]['year'][0]."</td></tr>\n";
    echo "<tr><td align=\"left\" >Track Number:</td>\n";
    echo "<td align=\"left\">".$ThisFileInfo['tags'][$id3]['track_number'][0]."</td></tr>\n";
    echo "<tr><td align=\"left\" >Genre:</td>\n";
    echo "<td align=\"left\">".$ThisFileInfo['tags'][$id3]['genre'][0]."</td></tr>\n";
    echo "<tr><td colspan=\"3\"><hr></td>\n";
    echo "<tr><td align=\"left\"><b>Description</b></td></tr>\n";
    echo "<tr><td align=\"left\" >Title:</td>\n";
    echo "<td align=\"left\">".$ThisFileInfo['tags'][$id3]['title'][0]."</td></tr>\n";
    echo "<tr><td align=\"left\" >Comments:</td>\n";
    echo "<td align=\"left\">".$ThisFileInfo['tags'][$id3]['comments'][0]."</td></tr>\n";
    echo "<tr><td colspan=\"3\"><hr></td>\n";
    echo "<tr><td align=\"left\"><b>Origin</b></td></tr>\n";
    echo "<tr><td align=\"left\" >Protected:</td>\n";
    if ( $ThisFileInfo['mpeg']['audio']['protection'] == "TRUE")
        $protected="Yes";
    else
        $protected="No";
    echo "<td align=\"left\">".$protected."</td></tr>\n";
    echo "<tr><td colspan=\"3\"><hr></td>\n";
    echo "<tr><td align=\"left\"><b>Audio</b></td></tr>\n";
    echo "<tr><td align=\"left\" >Duration:</td>\n";
    echo "<td align=\"left\">".$ThisFileInfo['playtime_string']."</td></tr>\n";
    echo "<tr><td align=\"left\" >Bit Rate:</td>\n";
    echo "<td align=\"left\">".round($ThisFileInfo['audio']['bitrate'] / 1000)."kbps</td></tr>\n";
    echo "<tr><td align=\"left\" >Channels:</td>\n";
    echo "<td align=\"left\">".$ThisFileInfo['audio']['channels']." (".$ThisFileInfo['audio']['channelmode'].")</td></tr>\n";
    echo "<tr><td align=\"left\" >Audio Sample Rate:</td>\n";
    echo "<td align=\"left\">".round($ThisFileInfo['audio']['sample_rate']/1000)."kHz</td></tr>\n";
}
// Video Files
else if (isset($ThisFileInfo['fileformat']) && ($ThisFileInfo['fileformat'] == "quicktime" || 
	$ThisFileInfo['fileformat'] == "riff" || $ThisFileInfo['fileformat'] == "asf" || 
	$ThisFileInfo['fileformat'] == "mpeg" || $ThisFileInfo['fileformat'] == "matroska" || 
	$ThisFileInfo['fileformat'] == "real")) {
    echo "<tr><td align=\"left\"><b>Video</b></td></tr>\n";
    echo "<tr><td align=\"left\" >Dimensions:</td>\n";
    echo "<td align=\"left\">".$ThisFileInfo['video']['resolution_x']." X ".$ThisFileInfo['video']['resolution_y']."</td></tr>\n";
    if ($ThisFileInfo['fileformat'] != "matroska") {
        echo "<tr><td align=\"left\" >Codec:</td>\n";
        if ($ThisFileInfo['fileformat'] != "asf")
            echo "<td align=\"left\">".$ThisFileInfo['video']['codec']."</td></tr>\n";
        else
            echo "<td align=\"left\">".$ThisFileInfo['video']['streams']['2']['codec']."</td></tr>\n";
    }
    if (isset($ThisFileInfo['video']['bits_per_sample'])) {
        echo "<tr><td align=\"left\" >Bits Per Sample:</td>\n";
        echo "<td align=\"left\">".$ThisFileInfo['video']['bits_per_sample']."</td></tr>\n";
    }
    if (isset($ThisFileInfo['video']['bitrate'])) {
        echo "<tr><td align=\"left\" >Bits Rate:</td>\n";
        echo "<td align=\"left\">".round($ThisFileInfo['video']['bitrate']/1000)."kbps</td></tr>\n";
    }
    if ($ThisFileInfo['fileformat'] != "asf") {
        echo "<tr><td align=\"left\" >Frame Rate:</td>\n";
        echo "<td align=\"left\">".$ThisFileInfo['video']['frame_rate']."</td></tr>\n";
    }
    if (isset($ThisFileInfo['audio'])) {
        echo "<tr><td colspan=\"3\"><hr></td>\n";
        echo "<tr><td align=\"left\"><b>Audio</b></td></tr>\n";
        echo "<tr><td align=\"left\" >Codec:</td>\n";
        if (! isset($ThisFileInfo['audio']['codec']) || $ThisFileInfo['audio']['codec'] == "")
            $codec="Unknown";
        else
            $codec=$ThisFileInfo['audio']['codec'];
        echo "<td align=\"left\">".$codec."</td></tr>\n";
        echo "<tr><td align=\"left\" >Sample Rate:</td>\n";
        echo "<td align=\"left\">".round($ThisFileInfo['audio']['sample_rate']/1000)."kHz</td></tr>\n";
        echo "<tr><td align=\"left\" >Channels:</td>\n";
        if (isset($ThisFileInfo['audio']['channelmode'])) 
            $channelmode="(".$ThisFileInfo['audio']['channelmode'].")";
        else
            $channelmode="";
        echo "<td align=\"left\">".$ThisFileInfo['audio']['channels']." ".$channelmode."</td></tr>\n";
        if (isset($ThisFileInfo['audio']['bitrate'])) {
            echo "<tr><td align=\"left\" >Bits Rate:</td>\n";
            echo "<td align=\"left\">".round($ThisFileInfo['audio']['bitrate']/1000)."kbps</td></tr>\n";
        }
    }
    echo "<tr><td colspan=\"3\"><hr></td>\n";
    echo "<tr><td align=\"left\"><b>Others</b></td></tr>\n";
    echo "<tr><td align=\"left\" >Duration:</td>\n";
    echo "<td align=\"left\">".$ThisFileInfo['playtime_string']."</td></tr>\n";
    if (isset($ThisFileInfo['bitrate'])) {
        echo "<tr><td align=\"left\" >Bits Rate:</td>\n";
        echo "<td align=\"left\">".round($ThisFileInfo['bitrate']/1000)."kbps</td></tr>\n";
    }
    if (isset($ThisFileInfo['comments']['comment'])){
        echo "<tr><td align=\"left\" >Comments:</td>\n";
        echo "<td align=\"left\">".$ThisFileInfo['comments']['comment'][0]."</td></tr>\n";
    }
    if (isset($ThisFileInfo['comments']['copyright'])){
        echo "<tr><td align=\"left\" >Copyright:</td>\n";
        echo "<td align=\"left\">".$ThisFileInfo['comments']['copyright'][0]."</td></tr>\n";
    }
    if (isset($ThisFileInfo['comments']['title'])){
        echo "<tr><td align=\"left\" >Title:</td>\n";
        echo "<td align=\"left\">".$ThisFileInfo['comments']['title'][0]."</td></tr>\n";
    }
}
// Image Files
else if (isset($ThisFileInfo['fileformat']) && ($ThisFileInfo['fileformat'] == "png" || 
	$ThisFileInfo['fileformat'] == "jpg" || $ThisFileInfo['fileformat'] == "gif" ||
	$ThisFileInfo['fileformat'] == "bmp" || $ThisFileInfo['fileformat'] == "tiff")) {
    echo "<tr><td align=\"left\"><b>Image</b></td></tr>\n";
    echo "<tr><td align=\"left\" >Width:</td>\n";
    echo "<td align=\"left\">".$ThisFileInfo['video']['resolution_x']."</td></tr>\n";
    echo "<tr><td align=\"left\" >Height:</td>\n";
    echo "<td align=\"left\">".$ThisFileInfo['video']['resolution_y']."</td></tr>\n";
    if (isset($ThisFileInfo['jpg']['exif']['IFD0']['XResolution'])) {
        $x_res=explode("/",$ThisFileInfo['jpg']['exif']['IFD0']['XResolution']);
        $y_res=explode("/",$ThisFileInfo['jpg']['exif']['IFD0']['YResolution']);
        echo "<tr><td align=\"left\" >Horizontal Resolution:</td>\n";
        echo "<td align=\"left\">".$x_res[0]." dpi</td></tr>\n";
        echo "<tr><td align=\"left\" >Vertical Resolution:</td>\n";
        echo "<td align=\"left\">".$y_res[0]." dpi</td></tr>\n";
    }
    if (isset($ThisFileInfo['video']['bits_per_sample'])) {
        echo "<tr><td align=\"left\" >Bit Depth:</td>\n";
        echo "<td align=\"left\">".$ThisFileInfo['video']['bits_per_sample']."</td></tr>\n";
    }
    if (isset($ThisFileInfo['jpg']['exif']['IFD0']['Make'])) {
        echo "<tr><td align=\"left\" >Equipment Make:</td>\n";
        echo "<td align=\"left\">".$ThisFileInfo['jpg']['exif']['IFD0']['Make']."</td></tr>\n";
    }
    if (isset($ThisFileInfo['jpg']['exif']['IFD0']['Model'])) {
        echo "<tr><td align=\"left\" >Camera Model:</td>\n";
        echo "<td align=\"left\">".$ThisFileInfo['jpg']['exif']['IFD0']['Model']."</td></tr>\n";
    }
    if (isset($ThisFileInfo['jpg']['exif']['IFD0']['DateTime'])) {
        echo "<tr><td align=\"left\" >Date Picture Taken:</td>\n";
        $tme=explode(":",str_replace(" ",":",$ThisFileInfo['jpg']['exif']['IFD0']['DateTime']));
        $fdate = date($date_format,mktime($tme[3],$tme[4],$tme[5],$tme[1],$tme[2],$tme[0]));
        echo "<td align=\"left\">".$fdate."</td></tr>\n";
    }
    echo "<tr><td align=\"left\" >Frame Count:</td>\n";
    echo "<td align=\"left\">1</td></tr>\n";
    if (isset($ThisFileInfo['comments'])) {
    echo "<tr><td colspan=\"3\"><hr></td>\n";
    echo "<tr><td align=\"left\"><b>Comments</b></td></tr>\n";
        $comments=array_keys($ThisFileInfo['comments']);
        for ($i=0;$i<count($comments);$i++) {
            echo "<tr><td align=\"left\" >$comments[$i]:</td>\n";
            echo "<td align=\"left\">".$ThisFileInfo['comments'][$comments[$i]][0]."</td></tr>\n";
        }
    }
}
else if (isset($ThisFileInfo['fileformat']) && ($ThisFileInfo['fileformat'] == "zip")){
    echo "<tr><td align=\"center\"><b>ZIP Archive</b></td></tr>\n";
}
else
    echo "<tr><td align=\"left\">Summary properties are unavailable for the selected source(s).</td></tr>\n";
echo "</table>\n";
echo "</body>\n";
?>
