<?php
// +-----------------------------------------------------------------------+
// |                                                                       |
// | THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS   |
// | "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT     |
// | LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR |
// | A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT  |
// | OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, |
// | SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT      |
// | LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, |
// | DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY |
// | THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT   |
// | (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE |
// | OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.  |
// |                                                                       |
// +-----------------------------------------------------------------------+

if(is_readable("_include/config.php"))
    include "_include/config.php";
else
    include "config.php";

if(is_readable("_include/functions.php"))
    include "_include/functions.php";
else
    include "functions.php";

ini_set("session.save_path", $tmpdir);
session_start();
session_cache_limiter('nocache');
header("Cache-Control: no-cache, must-revalidate"); // HTTP/1.1
header("Expires: Sat, 26 Jul 1997 05:00:00 GMT"); // Date in the past

$text=array("User:","Group:","Others:");
if (isset($_GET["item"]))
    $item=str_replace("\\","",$_GET["item"]);
    $baseitem=basename($item);
if (isset($_GET["type"]))
    $type=$_GET["type"];
else
    $type="Unknown File";
if (isset($_GET["filesystem"]))
    $filesystem=$_GET["filesystem"];

$location=dirname($_GET["item"]);

$fileFullPath=$location.'/'.$baseitem;
$contains="0 Files, 0 Folders";
if ($type != "Local Disk" && $type != "Network Drive" && $type != "Removable Disk"  && $type != "Desktop" &&
    $type != "Ram Drive" && $type != "CD/DVD Drive") {
    $image=str_replace("18","32",get_mime_type($fileFullPath, "img"));
    if ($image=="") $image="unknown.png";
    $ftype=get_mime_type($fileFullPath, "type");
    if ($ftype=="") $ftype="Unknown File";
    if ($type == "File Folder") {
        $dirinfo=dirSize($fileFullPath);
        if ($dirinfo[0] != 0){
            $size=$dirinfo[0];
        }
        else
            $size="0";
        $contains=$dirinfo[1]." Files, ".$dirinfo[2]." Folders";
    }
    else
        $size=(float)File_Size($fileFullPath);
    if (is_readable($fileFullPath)) {
        $cdate=date ("l, F j, Y, g:i:s A", filectime($fileFullPath));
        $mdate=date ("l, F j, Y, g:i:s A", filemtime($fileFullPath));
        $adate=date ("l, F j, Y, g:i:s A", fileatime($fileFullPath));
    }
    else {
        $cdate=date ("l, F j, Y, g:i:s A", trim(exec('stat -c %Z '.escapeshellarg($fileFullPath))));
        $mdate=date ("l, F j, Y, g:i:s A", trim(exec('stat -c %Y '.escapeshellarg($fileFullPath))));
        $adate=date ("l, F j, Y, g:i:s A", trim(exec('stat -c %X '.escapeshellarg($fileFullPath))));
    }

?>
<body style="background-color:#F0F8FF;margin:10px;padding:0px;overflow:hidden;">
<TABLE cellspacing=6 style="font-family:Tahoma;font-size:12px;" width="100%" style="margin:0px;"><tbody>
<?php
    echo "<TR><TD style='width:100px;'>&nbsp;<img src='_img/32x32/".$image."'></TD>\n";
    echo "<TD colspan='5' align=\"left\"><input id=\"baseitem\" type=\"text\" size=50 value=\"".$baseitem."\" style='border:0px;height:16px;background-color: #ffffff' readonly></TD></TR>\n";
    echo "<TR><TD colspan=\"5\"><HR></TD></TR>\n";
    echo "<TR><TD align=\"left\" >Type:</TD>\n";
    echo "<TD colspan='5' align=\"left\">$type</TD></TR>\n";
    echo "<TR><TD align=\"left\" >Location:</TD>\n";
    echo "<TD colspan='5' align=\"left\"><input id=\"location\" type=\"text\" size=50 value='".$location."' style='border:0px;height:16px;background-color: #ffffff' readonly></TD></TR>\n";
    echo "<TR><TD align=\"left\" >Size:</TD>\n";
    if ($size == 0)
        echo "<TD colspan='5' align=\"left\">0 bytes</TD></TR>\n";
    else
        echo "<TD colspan='5' align=\"left\">".parse_fsize($size)." (".pretty_number($size)." bytes)</TD></TR>\n";
    if (is_dir($fileFullPath)) {
        echo "<TR><TD align=\"left\" >Contains:</TD>\n";
        echo "<TD colspan='5' align=\"left\">$contains</TD></TR>\n";
    }
    echo "<TR><TD colspan=\"5\"><HR></TD></TR>\n";
    echo "<TR><TD align=\"left\" >Created:</TD>\n";
    echo "<TD colspan='5' align=\"left\">$cdate</TD></TR>\n";
    echo "<TR><TD align=\"left\" >Modified:</TD>\n";
    echo "<TD colspan='5' align=\"left\">$mdate</TD></TR>\n";
    echo "<TR><TD align=\"left\" >Accessed:</TD>\n";
    echo "<TD colspan='5' align=\"left\">$adate</TD></TR>\n";
    echo "<TR><TD colspan='5'><HR></TD></TR>\n";
    echo "<TR><TD align=\"left\" >Permissions:</TD></TR>\n";
    
    $oct_perms=get_file_perms($location, $baseitem);
    if ($oct_perms == 0)
        $mode = parse_file_perms(trim(exec('stat -c %a '.escapeshellarg($location.'/'.$baseitem))));
    else
        $mode = parse_file_perms(get_file_perms($location, $baseitem));

    $pos = "rwx";

    // print Table with current perms & checkboxes to change
    for($i=0;$i<3;++$i) {
        echo "<TR><TD></TD><TD align=\"left\">" .$text[$i]. "</TD>";
            for($j=0;$j<3;++$j) {
                    echo "<TD>" . $pos{$j} . "&nbsp;<INPUT type=\"checkbox\"";
                    if($mode{(3*$i)+$j} != "-") echo " checked";
                        echo " id=\"r_" . $i.$j . "\" name=\"r_" . $i.$j . "\" value=\"1\"></TD>";
            }
            echo "</TR>\n";
    }
    if ($type == "File Folder") {
        echo "<TR><TD colspan=\"5\"><HR></TD></TR>\n";
        echo "<TR><TD colspan=\"2\" align=\"left\" width=\"100%\"><input id=\"recursive\" type=\"checkbox\">Set Permissions recursively</TD></TR>\n";
    }
    echo "</tbody></TABLE>\n";
    echo "</body>\n";
}
else if ($type != "Desktop"){
    if ($type == "Local Disk")
        $image="harddrive.png";
    else if ($type == "Network Drive")
        $image="networkdrive.png";
    else if ($type == "Removable Disk")
        $image="usbdrive.png";
    else if ($type == "Ram Drive")
        $image="ramdrive.png";
    else if ($type == "CD/DVD Drive")
        $image="dvddrive.png";

    if ($baseitem == "")
        $baseitem="Root Disk";

    $total_space = disk_total_space($item);
    $total_fsize = parse_fsize($total_space);
    $free_space = disk_free_space($item);
    $free_fsize = parse_fsize($free_space);
    $used_space_percent=(($total_space-$free_space)/$total_space)*100;
    $free_space_percent=100-$used_space_percent;
    $uspace=sprintf("%35s %20s",pretty_number($total_space-$free_space)." bytes", parse_fsize($total_space-$free_space));
    $fspace=sprintf("%35s %20s",pretty_number($free_space)." bytes",$free_fsize);
    $tspace=sprintf("%35s %20s",pretty_number($total_space)." bytes",$total_fsize);
    $uspace=str_replace(" ","&nbsp;",$uspace);
    $fspace=str_replace(" ","&nbsp;",$fspace);
    $tspace=str_replace(" ","&nbsp;",$tspace);

    echo "<body bgcolor=\"#f6f6ee\">\n";
    echo "<TABLE cellspacing=6 style=\"font-family:Tahoma;font-size:12px;\" width=\"100%\" style=\"margin:0px;\">\n";
    echo "<TR><TD>&nbsp;&nbsp;<img src='_img/32x32/".$image."'></TD>\n";
    echo "<TD align=\"left\"><input id=\"baseitem\" type=\"text\" size=50 value='".$baseitem."' style='border:0px;height:16px;background-color: #ffffff' readonly></TD></TR>\n";
    echo "<TR><TD colspan=\"5\"><HR></TD></TR>\n";
    echo "<TR><TD align=\"left\" >Type:</TD>\n";
    echo "<TD align=\"left\">$type</TD></TR>\n";
    echo "<TR><TD align=\"left\" >File System:</TD>\n";
    echo "<TD align=\"left\">$filesystem</TD></TR>\n";
    echo "<TR><TD colspan=\"5\"><HR></TD></TR>\n";
    echo "</TABLE>\n";
    echo "<TABLE cellspacing=6 style=\"font-family:Tahoma;font-size:12px;\" width=\"100%\" style=\"margin:0px;\">\n";
    echo "<TR><TD align=\"left\"><input type=\"password\" style=\"width:15px;height=15px;background-color:#CCD6E0;\" disabled>&nbsp;Used Space:</TD>\n";
    echo "<TD align=\"right\" width=\"50%\">$uspace</TD></TR>\n";
    echo "<TR><TD align=\"left\" ><input type=\"password\" style=\"width:15px;height=15px;background-color:#7F99B2;\" disabled>&nbsp;Free Space:</TD>\n";
    echo "<TD align=\"right\">$fspace</TD></TR>\n";
    echo "<TR><TD colspan=\"5\"><HR></TD></TR>\n";
    echo "<TR><TD align=\"left\" >Capacity:</TD>\n";
    echo "<TD align=\"right\">$tspace</TD></TR>\n";
    echo "</TABLE>\n";
    echo "<TABLE cellspacing=7 style=\"font-family:Tahoma;font-size:12px;\" width=\"100%\" style=\"margin:0px;\">\n";
    echo "<TR><TD align=\"center\"><img src=\"_include/piechart.php?data=".round($used_space_percent)."*".round($free_space_percent)."\"></TD></TR>\n";
    echo "</TABLE>\n";
}
else {
    if (file_exists("/opt/sybhttpd/localhost.drives/SATA_DISK/"))
        $img = "model-C200.jpg";
    else
        $img = "model-A100.png";

    echo "<body bgcolor=\"#f6f6ee\">\n";
    echo "<TABLE cellspacing=7 style=\"font-family:Tahoma;font-size:12px;\" width=\"100%\" style=\"margin:0px;\">\n";
    echo "<TR><TD align=\"left\"><img src=\"_img/".$img."\"></TD></TR>\n";
    echo "</TABLE>\n";
    echo "<TABLE cellspacing=7 style=\"font-family:Tahoma;font-size:12px;\" width=\"100%\" style=\"margin:0px;\">\n";
    echo "<TR><TD align=\"left\" >Manufactured By:</TD>\n";
    echo "<TD align=\"left\"><input id=\"baseitem\" type=\"text\" size=50 value='".$baseitem."' style='border:0px;height:16px;background-color: #ffffff' readonly></TD></TR>\n";
    echo "</TABLE>\n";
}
?>
