<?php
// +-----------------------------------------------------------------------+
// |                                                                       |
// | THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS   |
// | "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT     |
// | LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR |
// | A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT  |
// | OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, |
// | SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT      |
// | LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, |
// | DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY |
// | THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT   |
// | (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE |
// | OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.  |
// |                                                                       |
// +-----------------------------------------------------------------------+

if(is_readable("_include/config.php"))
    include "_include/config.php";
else
    include "config.php";

if(is_readable("_include/functions.php"))
    include "_include/functions.php";
else
    include "functions.php";

if(isset($_GET["id"]))
    $id=$_GET["id"];

if(isset($_GET["device"]))
    $device=$_GET["device"];

if ($id == "identity") {
    global $tmpdir, $utildir;

    $file = tempnam($tmpdir,'.smartctl');
    shell_exec($utildir."sbin/smartctl -iH ".$device." > ".$file);
    //$arr = file("/share/Apps/hdd_i.txt");
    $arr = file($file);
    $output = array_keys(preg_grep('/smartctl version/',$arr));
    $smartctl_version = explode(" ", $arr[$output[0]]);
    $output = array_keys(preg_grep('/Model Family:/',$arr));
    if ($output)
        $model_family = explode(":", $arr[$output[0]]);
    else
        $model_family[1] = "Unknown";
    $output = array_keys(preg_grep('/Device Model:/',$arr));
    $device_model = explode(":", $arr[$output[0]]);
    $output = array_keys(preg_grep('/Serial Number:/',$arr));
    $serial_number = explode(":", $arr[$output[0]]);
    $output = array_keys(preg_grep('/Firmware Version:/',$arr));
    $firmware_version = explode(":", $arr[$output[0]]);
    $output = array_keys(preg_grep('/User Capacity:/',$arr));
    $user_capacity = explode(":", $arr[$output[0]]);
    $user_capacity_in_bytes=(float)trim(str_replace(",","",str_replace("bytes", "",$user_capacity[1])));
    $user_capacity_in_GiB=round($user_capacity_in_bytes/1073741824,2);
    $user_capacity_in_GB=round($user_capacity_in_bytes/1000000000,2);
    $output = array_keys(preg_grep('/ATA Version is:/',$arr));
    $ata_version = explode(":", $arr[$output[0]]);
    $output = array_keys(preg_grep('/ATA Standard is:/',$arr));
    $ata_standard = explode(":", $arr[$output[0]]);
    $output = array_keys(preg_grep('/Local Time is:/',$arr));
    $local_time = explode(":", $arr[$output[0]]);
    $local_time = $local_time[1].':'.$local_time[2].':'.$local_time[3];
    $output = array_keys(preg_grep('/SMART support is:/',$arr));
    $smart_support_avail = explode(":", $arr[$output[0]]);
    if (trim($smart_support_avail[1]) == "Available - device has SMART capability." )
        $smart_support_avail="Yes";
    else
        $smart_support_avail="No";
    $smart_support_enabled = explode(":", $arr[$output[1]]);
    if (trim($smart_support_enabled[1]) == "Enabled" )
        $smart_support_enabled="Yes";
    else
        $smart_support_enabled="No";
    $output = array_keys(preg_grep('/SMART overall-health/',$arr));
    $smart_health = explode(":", $arr[$output[0]]);
    unlink($file);

    // Print identity html
    echo "<table cellspacing=8 style=\"font-family:Tahoma;font-size:12px;\" width=\"100%\" style=\"margin-top:10px;\">\n";
    echo "<tr><td align=\"right\"><b>Model Family</b></td>\n";
    echo "<td align=\"left\">".trim($model_family[1])."</td></tr>\n";
    echo "<tr><td align=\"right\"><b>Device Model</b></td>\n";
    echo "<td align=\"left\">".trim($device_model[1])."</td></tr>\n";
    echo "<tr><td align=\"right\"><b>Serial Number</b></td>\n";
    echo "<td align=\"left\">".trim($serial_number[1])."</td></tr>\n";
    echo "<tr><td align=\"right\"><b>Firmware Version</b></td>\n";
    echo "<td align=\"left\">".trim($firmware_version[1])."</td></tr>\n";
    echo "<tr><td align=\"right\"><b>User Capacity</b></td>\n";
    echo "<td align=\"left\">".$user_capacity_in_GB." GB [".$user_capacity_in_GiB." GiB, ".str_replace(",","",trim($user_capacity[1]))."]</td></tr>\n";
    echo "<tr><td align=\"right\"><b>ATA Version</b></td>\n";
    echo "<td align=\"left\">".trim($ata_version[1])."</td></tr>\n";
    echo "<tr><td align=\"right\"><b>ATA Standard</b></td>\n";
    echo "<td align=\"left\">".trim($ata_standard[1])."</td></tr>\n";
    echo "<tr><td align=\"right\"><b>Scanned on</b></td>\n";
    echo "<td align=\"left\">".trim($local_time)."</td></tr>\n";
    echo "<tr><td align=\"right\"><b>SMART supported</b></td>\n";
    echo "<td align=\"left\">".$smart_support_avail."</td></tr>\n";
    echo "<tr><td align=\"right\"><b>SMART enabled</b></td>\n";
    echo "<td align=\"left\">".$smart_support_enabled."</td></tr>\n";
    echo "<tr><td align=\"right\"><b>Smartctl version</b></td>\n";
    echo "<td align=\"left\">".trim($smartctl_version[2])."</td></tr>\n";
    echo "<tr><td>&nbsp;</td></tr>\n";
    echo "<tr><td align=\"right\"><b>Overall health self-assesment test</b></td>\n";
    echo "<td align=\"left\">".trim($smart_health[1])."</td></tr>\n";
    echo "</table>\n";
}
else if ($id == "attributes") {
    global $tmpdir;
    ini_set("session.save_path", $tmpdir);
    session_start();

    if ( stristr($_SERVER["HTTP_ACCEPT"],"application/xhtml+xml") ) {
        header("Content-type: application/xhtml+xml"); } else {
        header("Content-type: text/xml");
    }
    print("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
    print("<!-- start grid xml -->");
    print("<rows id=\"0\">");

    $file = tempnam($tmpdir,'smartctl.');
    shell_exec($utildir."sbin/smartctl -A ".$device." > ".$file);
    //$arr = file("/share/fileman/hdd.txt");
    //$arr = file($file);
    $data = file_get_contents($file);
    unlink($file);

    preg_match("/ID# (.+?)\n$/sm",$data, $output);
    $attributes=preg_replace('/\s+/', '|', $output[0]);

    $attributes=explode("|",$attributes);
    $count = count($attributes);
    for($i=10;$i<$count-1;$i+=10) {
        if ($attributes[$i+7] == "Always")
            $updated="continuously";
        else if ($attributes[$i+7] == "Offline")
            $updated="on offline data collection";
        if ($attributes[$i+6] == "Pre-fail")
            $type="pre-failure";
        else if ($attributes[$i+6] == "Old_age")
            $type="old age";
        else if ($attributes[$i+6] == "-")
            $type="never";
        if ($attributes[$i+8] == "FAILING_NOW"){
            $when_failed="now";
            $style='background-color:red';
        }
        else if ($attributes[$i+8] == "In_the_past"){
            $when_failed="past";
            $style='background-color:orange';
        }
        else if ($attributes[$i+8] == "-"){
            $when_failed="never";
            $style="";
        }
        print('<row id="'.$attributes[$i].'" style="'.$style.'">');
        print("<cell><![CDATA[".$attributes[$i]."]]></cell>");
        print("<cell style='font-weight:bold;".$style."'><![CDATA[".str_replace("_"," ",$attributes[$i+1])."]]></cell>");
        print("<cell><![CDATA[".$when_failed."]]></cell>");
        print("<cell><![CDATA[".$attributes[$i+3]."]]></cell>");
        print("<cell><![CDATA[".$attributes[$i+4]."]]></cell>");
        print("<cell><![CDATA[".$attributes[$i+5]."]]></cell>");
        print("<cell><![CDATA[".$attributes[$i+9]."]]></cell>");
        print("<cell><![CDATA[".$type."]]></cell>");
        print("<cell><![CDATA[".$updated."]]></cell>");
        print("<cell><![CDATA[".$attributes[$i+2]."]]></cell>");
        print("</row>");
    }
    print("<!-- close grid xml -->");
    print("</rows>");
}
else if ($id == "capabilities") {
}
else if ($id == "error_log") {
}
else if ($id == "self_test_log") {
}
else if ($id == "perform_tests") {
}
?>
